from orchestrator.domain.base import SubscriptionModel
from orchestrator.types import SubscriptionLifecycle

from geant_service_orchestrator.products.product_blocks.trunk_config \
    import TrunkConfigBlock, TrunkConfigBlockInactive,\
    TrunkConfigBlockProvisioning


class TrunkConfigInactive(
        SubscriptionModel,
        is_base=True, lifecycle=[SubscriptionLifecycle.INITIAL]):
    trunk_config: TrunkConfigBlockInactive


class TrunkConfigProvisioning(
        TrunkConfigInactive,
        lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    trunk_config: TrunkConfigBlockProvisioning


class TrunkConfig(
        TrunkConfigProvisioning,
        lifecycle=[SubscriptionLifecycle.ACTIVE]):
    trunk_config: TrunkConfigBlock
