from orchestrator.domain.base import SubscriptionModel
from orchestrator.types import SubscriptionLifecycle

from geant_service_orchestrator.products.product_blocks.trunk_config_common \
    import TrunkConfigCommonBlock, TrunkConfigCommonBlockInactive, \
    TrunkConfigCommonBlockProvisioning


class TrunkConfigCommonInactive(
        SubscriptionModel,
        is_base=True,
        lifecycle=[SubscriptionLifecycle.INITIAL]):
    trunk_config_common: TrunkConfigCommonBlockInactive


class TrunkConfigCommonProvisioning(
        TrunkConfigCommonInactive,
        lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    trunk_config_common: TrunkConfigCommonBlockProvisioning


class TrunkConfigCommon(
        TrunkConfigCommonProvisioning,
        lifecycle=[SubscriptionLifecycle.ACTIVE]):
    trunk_config_common: TrunkConfigCommonBlock
