from orchestrator.domain.base import SubscriptionModel
from orchestrator.types import SubscriptionLifecycle

from geant_service_orchestrator.products.product_blocks.trunk_config_side \
    import TrunkConfigSideBlock, TrunkConfigSideBlockInactive, \
    TrunkConfigSideBlockProvisioning


class TrunkConfigSideInactive(
        SubscriptionModel,
        is_base=True,
        lifecycle=[SubscriptionLifecycle.INITIAL]):
    trunk_config_side: TrunkConfigSideBlockInactive


class TrunkConfigSideProvisioning(
        TrunkConfigSideInactive,
        lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    trunk_config_side: TrunkConfigSideBlockProvisioning


class TrunkConfigSide(
        TrunkConfigSideProvisioning,
        lifecycle=[SubscriptionLifecycle.ACTIVE]):
    trunk_config_side: TrunkConfigSideBlock
